package com.engine.organization.util.relation;

import com.engine.organization.entity.commom.RecordInfo;
import com.engine.organization.entity.job.po.JobPO;
import com.engine.organization.mapper.comp.CompMapper;
import com.engine.organization.mapper.department.DepartmentMapper;
import com.engine.organization.mapper.hrmresource.SystemDataMapper;
import com.engine.organization.mapper.job.JobMapper;
import com.engine.organization.util.db.MapperProxyFactory;
import org.apache.commons.collections.CollectionUtils;

import java.util.List;

/**
 * @author:dxfeng
 * @createTime: 2022/07/13
 * @version: 1.0
 */
public class EcHrmRelationUtil {

    private static final String HRM_COMPANY = "hrmsubcompany";
    private static final String HRM_DEPARTMENT = "hrmdepartment";


    private static SystemDataMapper getSystemDataMapper() {
        return MapperProxyFactory.getProxy(SystemDataMapper.class);
    }

    private static CompMapper getCompMapper() {
        return MapperProxyFactory.getProxy(CompMapper.class);
    }

    private static DepartmentMapper getDepartmentMapper() {
        return MapperProxyFactory.getProxy(DepartmentMapper.class);
    }

    private static JobMapper getJobMapper() {
        return MapperProxyFactory.getProxy(JobMapper.class);
    }

    public static String getEcJobId(Long jclJobId) {
        JobPO jobById = getJobMapper().getJobById(jclJobId);
        if (null == jobById) {
            return "";
        }
        RecordInfo hrmJobTitleByName = MapperProxyFactory.getProxy(SystemDataMapper.class).getHrmJobTitleByName(jobById.getJobName());
        if (null == hrmJobTitleByName) {
            return "";
        }
        return hrmJobTitleByName.getId();
    }


    /**
     * 判断岗位名称是否共用
     * <p>存在返回true</p>
     *
     * @param jobName
     * @param id
     * @return
     */
    public static boolean isExistJob(String jobName, Long id) {
        List<JobPO> jobPOS = getJobMapper().listByNameExceptId(jobName, id);
        return CollectionUtils.isNotEmpty(jobPOS);
    }

    /**
     * 判断岗位名称是否共用
     * <p>不存在返回true</p>
     *
     * @param jobName
     * @param id
     * @return
     */
    public static boolean isNotExistJob(String jobName, Long id) {
        return !isExistJob(jobName, id);
    }

}
